<?php
/*
Plugin Name: WP Comment Images and Videos
Plugin URI: http://www.superstorefinder.net
Description: Transform your traditional Wordpress comments into advanced comments which allows you to upload and attach images, as well as displaying videos from major Video Providers such as YouTube, Vimeo, etc by pasting url.
Version: 1.2
Author: Joe Iz
Author URI: http://www.superstorefinder.net
*/

$wpciv_wp_base=plugins_url('', __FILE__); 
define('WPCIV_WP_BASE', $wpciv_wp_base);
define('WPCIV_WP_PUB_BASE', WPCIV_WP_BASE);
define('WPCIV_WP_CSS_BASE', WPCIV_WP_PUB_BASE."/css");

function wpciv_wp_head_scripts() {
	wp_enqueue_style( 'wpciv-font-awesome' , WPCIV_WP_CSS_BASE.'/font-awesome.css' , true , '4.1' );
}

add_action('wp_footer', 'wpciv_wp_head_scripts');


if (is_file(dirname(dirname(__FILE__)) . '/wpcomment-iv-extras.php')) {
    @include(dirname(dirname(__FILE__)) . '/wpcomment-iv-extras.php');
}



add_action('admin_head', 'wpcommentiv_admin_head');
function wpcommentiv_admin_head()
{
	if(isset($_GET['page'])){
    if (strpos($_GET['page'], 'wpcomment-iv/') === 0) {
        echo '<link type="text/css" rel="stylesheet" href="' .
        get_option('siteurl') . '/wp-content/plugins/wpcomment-iv/admin.css"/>';
    }
	}
}

add_filter('comment_text', 'wpcommentiv_comment_text');
function wpcommentiv_comment_text($comment = '')
{
    $options = get_option('wpcommentiv');
    $id = get_comment_ID();

    $images = $options['images'];
    if (!isset($images) || !is_numeric($images)) $images = 1;

    $url = get_option('siteurl');
    for ($i=0; $i<$images; $i++)
    {
        if (file_exists(ABSPATH . 'wp-content/wpcomment-iv/' . $id . ($i==0?'':('-'.$i)) . '-tn.jpg'))
        {
            $comment .= '<p><a href="' . $url . '/wp-content/wpcomment-iv/' . wpcommentiv_find_original($id, $i) . '"><img src="' . $url . '/wp-content/wpcomment-iv/' . $id . ($i==0?'':('-'.$i)) . '-tn.jpg"/></a></p>';
        }
		
		if (file_exists(ABSPATH . 'wp-content/wpcomment-iv/' . $id . ($i==0?'':('-'.$i)) . '-tn.png'))
        {
            $comment .= '<p><a href="' . $url . '/wp-content/wpcomment-iv/' . wpcommentiv_find_original($id, $i) . '"><img src="' . $url . '/wp-content/wpcomment-iv/' . $id . ($i==0?'':('-'.$i)) . '-tn.png"/></a></p>';
        }
		
		if (file_exists(ABSPATH . 'wp-content/wpcomment-iv/' . $id . ($i==0?'':('-'.$i)) . '-tn.gif'))
        {
            $comment .= '<p><a href="' . $url . '/wp-content/wpcomment-iv/' . wpcommentiv_find_original($id, $i) . '"><img src="' . $url . '/wp-content/wpcomment-iv/' . $id . ($i==0?'':('-'.$i)) . '-tn.gif"/></a></p>';
        }
    }
    return $comment;
}


add_action('comment_post', 'wpcommentiv_comment_post');
function wpcommentiv_comment_post($id)
{
    $options = get_option('wpcommentiv');

    $images = $options['images'];
    if (!isset($images) || !is_numeric($images)) $images = 1;

    for ($i=0; $i<$images; $i++)
    {
        $field = 'image' . ($i==0?'':$i);
        if ($_FILES[$field]['name'] != '')
        {
            $name = $id . ($i==0?'':('-'.$i));
            $dest = ABSPATH . 'wp-content/wpcomment-iv/' . $name;
			
			$thumb = ABSPATH . 'wp-content/wpcomment-iv/' . $name . '-tn';
            switch($_FILES[$field]['type'])
            {
                case 'image/jpeg':
                case 'image/pjpeg':
                    $dest .= '.jpg';
					$thumb .= '.jpg';
                    break;
                case 'image/png':
                    $dest .= '.png';
					$thumb .= '.png';
                    break;
                case 'image/gif':
                    $dest .= '.gif';
					$thumb .= '.gif';
                    break;
                default:
                    // try with jpg if mime type doen's match
                    $dest .= '.jpg';
					$thumb .= '.jpg';
            }
         
            move_uploaded_file($_FILES[$field]['tmp_name'], $dest);
            $res = wpcommentiv_thumb($dest, $thumb, (int)$options['width'], (int)$options['width'], $_FILES[$field]['type']);
            if (!$res) @unlink($dest);
        }
    }
}


add_action('comment_form', 'wpcommentiv_comment_form', 99);
function wpcommentiv_comment_form()
{
    
    if (!is_singular()) {
        return;
    }

    $options = get_option('wpcommentiv');
	
	
    if ($options['field'] == 0)
    {
        $images = $options['images'];
        if (!isset($images) || !is_numeric($images)) $images = 1;
        for ($i=0; $i<$images; $i++)
        {
            echo '<div class="UploadPicture" data-toggle="tooltip" data-placement="top" title="" data-original-title="Attach a Photo">
                                                    <i class="fa fa-camera" aria-hidden="true"></i>
                                                    <input type="file" name="image" id="comment_img" title="' . htmlspecialchars($options['label']) . '">
                                                </div>
												<div class="WPImageComment">
												
												<div class="closePopUp">
												<a data-close-popup="true" href="#" id="applyFilterOptionss">
												<i class="fa fa-times" aria-hidden="true"></i></a></div>
												<div class="blahimage"><img id="blah" src="" alt="" valign="bottom"/></div>
												</div>
												
												<style>
												.WPImageComment { clear: both; padding-top:40px;] display: block; }
												.UploadPicture .form-group { margin-bottom:0px;}
												.UploadPicture>input {position: absolute; top: 0; height:30px; width:400px; left:-30px; opacity:0; cursor:pointer;margin:0px; z-index:10;}
												.UploadPicture { display: inline-block; color: #c7c7c7; font-size:25px; position:absolute; padding: 0px 10px; line-height: 39px; width: 46px; overflow: hidden; height: 38px;  cursor:pointer;}
												.UploadPicture:hover { color:#999;}
												 .closePopUp{
													 position:absolute;
													float:right;
													vertical-align:top;
													margin-top:5px; 
													margin-left:15px; 
													display:none;
												}
												.closePopUp a{
												 color:#ff0000;
												 cursor:pointer;
												 font-size: 18px;
												}
												.filter-popup-is-shown .closePopUp{
												display:inline-block;
												}
												</style>';
        }
    } 
}


add_action('admin_menu', 'wpcommentiv_admin_menu');
function wpcommentiv_admin_menu()
{
    add_options_page('WP Comment Images/Videos', '<span class="dashicons dashicons-admin-comments"></span> WP Comment Images/Videos', 'manage_options', 'wpcomment-iv/options.php');
}

add_filter('delete_comment', 'wpcommentiv_delete_comment');
function wpcommentiv_delete_comment($id)
{
    $options = get_option('wpcommentiv');
    $images = $options['images'];
    if (!isset($images) || !is_numeric($images)) $images = 1;

    for ($i=0; $i<20; $i++)
    {
   
        if (file_exists(ABSPATH . 'wp-content/wpcomment-iv/' . $id . ($i==0?'':('-'.$i)) . '-tn.jpg'))
        {
            @unlink(ABSPATH . 'wp-content/wpcomment-iv/' . $id . ($i==0?'':('-'.$i)) . '-tn.jpg');
            @unlink(ABSPATH . 'wp-content/wpcomment-iv/' . wpcommentiv_find_original($id, $i));
        }
		
		if (file_exists(ABSPATH . 'wp-content/wpcomment-iv/' . $id . ($i==0?'':('-'.$i)) . '-tn.png'))
        {
            @unlink(ABSPATH . 'wp-content/wpcomment-iv/' . $id . ($i==0?'':('-'.$i)) . '-tn.png');
            @unlink(ABSPATH . 'wp-content/wpcomment-iv/' . wpcommentiv_find_original($id, $i));
        }
		
		if (file_exists(ABSPATH . 'wp-content/wpcomment-iv/' . $id . ($i==0?'':('-'.$i)) . '-tn.gif'))
        {
            @unlink(ABSPATH . 'wp-content/wpcomment-iv/' . $id . ($i==0?'':('-'.$i)) . '-tn.gif');
            @unlink(ABSPATH . 'wp-content/wpcomment-iv/' . wpcommentiv_find_original($id, $i));
        }
    }
}

add_filter('comment_notification_text', 'wpcommentiv_comment_notification_text', 10, 2);
add_filter('comment_moderation_text', 'wpcommentiv_comment_notification_text', 10, 2);
function wpcommentiv_comment_notification_text($message, $id)
{
    $options = get_option('wpcommentiv');
    $url = get_option('siteurl');
    $buffer = '';
    for ($i=0; $i<20; $i++)
    {
        if (file_exists(ABSPATH . 'wp-content/wpcomment-iv/' . $id . ($i==0?'':('-'.$i)) . '-tn.jpg'))
        {
            $buffer .= "*** This comment has an image: " . $url . "/wp-content/wpcomment-iv/" . wpcommentiv_find_original($id, $i) . "\r\n";
        }
		
		if (file_exists(ABSPATH . 'wp-content/wpcomment-iv/' . $id . ($i==0?'':('-'.$i)) . '-tn.png'))
        {
            $buffer .= "*** This comment has an image: " . $url . "/wp-content/wpcomment-iv/" . wpcommentiv_find_original($id, $i) . "\r\n";
        }
		
		if (file_exists(ABSPATH . 'wp-content/wpcomment-iv/' . $id . ($i==0?'':('-'.$i)) . '-tn.gif'))
        {
            $buffer .= "*** This comment has an image: " . $url . "/wp-content/wpcomment-iv/" . wpcommentiv_find_original($id, $i) . "\r\n";
        }
    }
    return $buffer . "\r\n" . $message;

}

add_action('wp_footer', 'wpcommentiv_wp_footer');
function wpcommentiv_wp_footer()
{
    if (!is_single() && !is_page()) return;
    $options = get_option('wpcommentiv');
    $images = $options['images'];
    if (!isset($images) || !is_numeric($images)) $images = 1;
    echo
    '
<script type="text/javascript">

	jQuery(".WPImageComment").find("[data-close-popup]").on("click", function(e) {

        e.preventDefault();

         jQuery("#blah").attr("src", "");
		 jQuery("#comment_img").attr("value", "")
		 jQuery(".closePopUp").css("display","none");
		  jQuery(".blahimage").css("display","none");


    });

function readURL(input) {

    if (input.files && input.files[0]) {
        var reader = new FileReader();

        reader.onload = function (e) {
            jQuery("#blah").attr("src", e.target.result);
			jQuery(".closePopUp").css("display","block");
			jQuery(".blahimage").css("display","block");
			
        }

        reader.readAsDataURL(input.files[0]);
    }
}

var cnt = jQuery(".form-submit").contents();
jQuery(".form-submit").replaceWith(cnt);

jQuery("#comment_img").change(function(){
    readURL(this);
});

for (i=0; i<document.forms.length; i++) {
    var f = document.forms[i];
    if (f.comment_post_ID) {
        f.encoding = "multipart/form-data";
';
    if ($options['field'] == 1)
    {
        echo
        '
        var l = f.getElementsByTagName("textarea");
        l = l[0].parentNode;
        ';
        for ($i=$images-1; $i>=0; $i--)
        {
            echo '
        var p = document.createElement("p");
        var t = document.createElement("input");
        t.setAttribute("name", "image' . ($i==0?'':$i) . '");
        t.setAttribute("type", "file");
        t.setAttribute("style", "width: auto");
        p.appendChild(t);
        p.appendChild(document.createTextNode("' . addslashes($options['label']) . '"));
        l.parentNode.insertBefore(p, l.nextSibling);
';
        }
    }
    echo
    '
        break;
    }
}
</script>
';
}


	
function wpcommentiv_thumb($file, $thumb, $new_w, $new_h, $type='image/jpeg')
{
    switch ($type)
    {
        case 'image/jpeg':
        case 'image/pjpeg':
            $src_img = imagecreatefromjpeg($file);
            break;
        case 'image/gif':
            $src_img = imagecreatefromgif($file);
            break;
        case 'image/png':
            $src_img = imagecreatefrompng($file);
            break;
        
        default:
            $src_img = imagecreatefromjpeg($file);
    }

    //$src_img = imagecreatefromjpeg($file);

    if ($src_img === false) return false;

    $old_x = imagesx($src_img);
    $old_y = imagesy($src_img);
    if ($new_w == null)
    {
        $thumb_h = $new_h;
        $thumb_w=$old_x*($new_h/$old_y);
    }
    else
    {
        if ($old_x > $old_y)
        {
            $thumb_w=$new_w;
            $thumb_h=$old_y*($new_h/$old_x);
        }
        if ($old_x < $old_y)
        {
            $thumb_w=$old_x*($new_w/$old_y);
            $thumb_h=$new_h;
        }
        if ($old_x == $old_y)
        {
            $thumb_w=$new_w;
            $thumb_h=$new_h;
        }
    }
    $dst_img = @imagecreatetruecolor($thumb_w,$thumb_h);
	
	imagealphablending($dst_img, false);
	imagesavealpha($dst_img, true);
		
    imagecopyresampled($dst_img,$src_img,0,0,0,0,$thumb_w,$thumb_h,$old_x,$old_y);

	
	
	$orimage = imagecreatefromstring(file_get_contents($file));
    $exif = exif_read_data($file);
		


        if(!empty($exif['Orientation'])) {
            switch($exif['Orientation']) {
                case 8:
                    $dst_img = imagerotate($dst_img,90,0);
                    break;
                case 3:
                    $dst_img = imagerotate($dst_img,180,0);
                    break;
                case 6:
                    $dst_img = imagerotate($dst_img,-90,0);
                    break;
            }
        }
	
	   if($type == 'image/jpeg' || $type == 'image/pjpeg') {
			imagejpeg($dst_img, $thumb, 80);
		} elseif($type == 'image/gif') {
			imagegif($dst_img, $thumb);
		} elseif($type == 'image/png') {
			imagepng($dst_img, $thumb);

		}
		
   
    imagedestroy($dst_img);
    imagedestroy($src_img);
    return true;
}

register_activation_hook(__FILE__, 'wpcommentiv_activate');
function wpcommentiv_activate()
{
    @mkdir(ABSPATH . 'wp-content/wpcomment-iv');

    @include(dirname(__FILE__) . '/languages/en_US_options.php');
    if (WPLANG != '') @include(dirname(__FILE__) . '/languages/' . WPLANG . '_options.php');

    $options = get_option('wpcommentiv');
    if (is_array($options))
    {
        $options = array_merge($default_options, $options);
        update_option('wpcommentiv', $options);
    }
    else
    {
        update_option('wpcommentiv', $default_options);
    }
}

function wpcommentiv_find_original($id, $i)
{
    $name = $id . ($i==0?'':('-'.$i));
    if (is_file(ABSPATH . 'wp-content/wpcomment-iv/' . $name . '.jpg')) return $name . '.jpg';
    if (is_file(ABSPATH . 'wp-content/wpcomment-iv/' . $name . '.gif')) return $name . '.gif';
    if (is_file(ABSPATH . 'wp-content/wpcomment-iv/' . $name . '.png')) return $name . '.png';
}

class WPCIV_ES_oEmbed_Comments {

	function __construct() {
		add_action( 'init', array( $this, 'init' ) );
	}

	function init() {
		if ( is_admin() )
			return;

		$this->add_filter();
	}

	/**
	 * Setup filter on the correct priority to do oEmbed in comments
	 */
	function add_filter() {
		// create breaks oEmbed regex, make sure we go earlier
		$clickable = has_filter( 'get_comment_text', 'make_clickable' );
		$priority = ( $clickable ) ? $clickable - 1 : 10;

		add_filter( 'get_comment_text', array( $this, 'oembed_filter' ), $priority );
	}

	/**
	 * Safely add oEmbed media to a comment
	 */
	function oembed_filter( $comment_text ) {
		global $wp_embed;

		// Automatic discovery security code
		add_filter( 'embed_oembed_discover', '__return_false', 999 );
		$comment_text = $wp_embed->autoembed( $comment_text );

		// 
		remove_filter( 'embed_oembed_discover', '__return_false', 999 );

		return $comment_text;
	}
}

new WPCIV_ES_oEmbed_Comments;

?>